POJ 1040 Transportation

2023-12-15 18:08
文章标签 poj transportation 1040

本文主要是介绍POJ 1040 Transportation,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

链接:http://poj.org/problem?id=1040

Transportation

Time Limit: 1000MS Memory Limit: 10000K
Total Submissions: 4235 Accepted: 1725

Description

Ruratania is just entering capitalism and is establishing new enterprising activities in many fields in- cluding transport. The transportation company TransRuratania is starting a new express train from city A to city B with several stops in the stations on the way. The stations are successively numbered, city A station has number 0, city B station number m. The company runs an experiment in order to improve passenger transportation capacity and thus to increase its earnings. The train has a maximum capacity n passengers. The price of the train ticket is equal to the number of stops (stations) between the starting station and the destination station (including the destination station). Before the train starts its route from the city A, ticket orders are collected from all onroute stations. The ticket order from the station S means all reservations of tickets from S to a fixed destination station. In case the company cannot accept all orders because of the passenger capacity limitations, its rejection policy is that it either completely accept or completely reject single orders from single stations.

Write a program which for the given list of orders from single stations on the way from A to B determines the biggest possible total earning of the TransRuratania company. The earning from one accepted order is the product of the number of passengers included in the order and the price of their train tickets. The total earning is the sum of the earnings from all accepted orders.

Input

The input file is divided into blocks. The first line in each block contains three integers: passenger capacity n of the train, the number of the city B station and the number of ticket orders from all stations. The next lines contain the ticket orders. Each ticket order consists of three integers: starting station, destination station, number of passengers. In one block there can be maximum 22 orders. The number of the city B station will be at most 7. The block where all three numbers in the first line are equal to zero denotes the end of the input file.

Output

The output file consists of lines corresponding to the blocks of the input file except the terminating block. Each such line contains the biggest possible total earning.

Sample Input

10 3 4
0 2 1
1 3 5
1 2 7
2 3 10
10 5 4
3 5 10
2 4 9
0 2 5
2 5 8
0 0 0

Sample Output

19
34

Source
Central Europe 1995

大意——从A到B有若干个车站,编号从0到m,列车的最大载客量是n。每次列车开车之前,会从各个车站收集订票信息。一条订票信息包括:起点站,终点站,人数。票价在数值上等于起点站与终点站之间的车站数(包括终点站,不包括起点站)。由于列车的最大载客量是一定的,所以不一定能接受所有的订票。对于一条订票,只能全部接受,或者是全部拒绝。现在给你最大载客量n,车站总数m,以及order条订票信息,要你计算出接受某些订票使之利润最大,并且输出这个最大利润。

思路——显然这是一个DFS的问题,但必须进行剪枝操作。首先按起点站进行排序,如果起点站相同,则按终点站排。然后按着顺序DFS:每接受一个订单,就把沿线所在站载客量全部加上这个订单中的人数,如果发现哪个站的人数超过了最大载客量n,就必须停下来,这个订单是不能接受的,就把所在站载客量中加上的人数全部减下来。如果所有沿线所在站都没有超过n,就可以加上该订单的利润,开始测试下一个订单,测试完成之后取消沿线所在站加的人数回溯。每当开始测试订单时,就把已经能获得的利润用参数的形式传递过去,保存这个最大值max。最后把所有的情况都遍历之后,输出max即得结果。

复杂度分析——时间复杂度:O(order*log(order))+O((n/passe)^order),空间复杂度:O(order)

附上AC代码:


#include <iostream>
#include <cstdio>
#include <iomanip>
#include <string>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <queue>
using namespace std;
const double PI = acos(-1.0);
const double E = exp(1.0);
const short maxorder = 22; // 最大订票量
const short maxsta = 8; // 最大车站数,包括首站
short cap, sta, order; // 分别表示火车的容量,车站数(不包括首站)和订票量
short down[maxsta]; // 第i站下车的人数,包括首站
short ans; // 最终结果
struct ticket
{short start, des, pass;bool operator < (const ticket & p) const{if (start == p.start)return des < p.des;return start < p.start;} // 按此规则排序
} ord[maxorder];void dfs(short ord_num, short passe, short money);int main()
{ios::sync_with_stdio(false);while (cin >> cap >> sta >> order && (cap || sta || order)){for (int i=0; i<order; i++)cin >> ord[i].start >> ord[i].des >> ord[i].pass; // 订票信息sort(ord, ord+order);ans = 0;dfs(0, 0, 0);cout << ans << endl;}return 0;
}void dfs(short ord_num, short passe, short money)
{if (ord_num == order) // 订票量全部检查完毕{ans = max(ans, money);return;}if (ord_num > 0)for (int i=ord[ord_num-1].start+1; i<=ord[ord_num].start; ++i)passe -= down[i]; // 减去下车人数,计算当前车内人数if (passe+ord[ord_num].pass <= cap) // 检查是否超载{down[ord[ord_num].des] += ord[ord_num].pass; // 不超载,接受订票dfs(ord_num+1, passe+ord[ord_num].pass, money+ord[ord_num].pass*(ord[ord_num].des-ord[ord_num].start));down[ord[ord_num].des] -= ord[ord_num].pass; // 恢复现场,以便后面回溯}dfs(ord_num+1, passe, money); // 不接受订票
}


这篇关于POJ 1040 Transportation的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/497368

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i